#include <i2c.h>
#include "i2c_nixie.h"


UN_NIXIE_UNIT nixie_get_data;
UN_NIXIE_UNIT nixie_set_data;
rom BYTE Nixie_Unit_Address[NIXIE_UNIT_MAX_NUM] = {I2C_SLAVE_ADD_UNIT1,I2C_SLAVE_ADD_UNIT2,I2C_SLAVE_ADD_UNIT3,I2C_SLAVE_ADD_UNIT4};

void I2C_NIXIE_init(void);
void I2C_NIXIE_DataTrans(BYTE data);
BYTE I2C_NIXIE_write(BYTE p_unit_no, BYTE p_write_address, BYTE *p_write_data, BYTE p_date_len);
BYTE I2C_NIXIE_read(BYTE p_unit_no, BYTE p_read_address, BYTE *p_read_data, BYTE p_data_len);


void I2C_NIXIE_init(void)
{
	BYTE fi;
	
	for(fi = 0; fi < NIXIE_TUBE_NUM; fi++)
	{
		nixie_get_data.nixie_data.disp_num[fi] = 0;
		nixie_get_data.nixie_data.disp_ctrl_1[fi] = 0;
		nixie_get_data.nixie_data.disp_ctrl_2[fi] = 0;
	}
	for(fi = 0; fi < NIXIE_TUBE_NUM; fi++)
	{
		nixie_set_data.nixie_data.disp_num[fi] = 0;
		nixie_set_data.nixie_data.disp_ctrl_1[fi] = 0;
		nixie_set_data.nixie_data.disp_ctrl_2[fi] = 0;
	}	
}

void I2C_NIXIE_DataTrans(BYTE data)
{
	WriteI2C(data);						//f[^o͎s
	IdleI2C();							//oXACh҂
}

BYTE I2C_NIXIE_write(BYTE p_unit_no, BYTE p_write_address, BYTE *p_write_data, BYTE p_data_len)
{
	BYTE chip_address;
	BYTE fi;
	
	// p[^`FbN
	if(p_unit_no <= 0 || NIXIE_UNIT_MAX_NUM < p_unit_no)
	{	// ERROR
		return 1;
	}

	StartI2C();						//X^[go
	while(SSPCON2bits.SEN);			//o͊҂
	chip_address = Nixie_Unit_Address[p_unit_no-1];
	I2C_NIXIE_DataTrans(chip_address);		//`bvAhXƐf[^o
	I2C_NIXIE_DataTrans(p_write_address);	// ݃AhX

	for(fi = 0; fi < p_data_len; fi++)
	{
		I2C_NIXIE_DataTrans(*p_write_data++);
	}

	StopI2C();						//Xgbvo
	while(SSPCON2bits.SEN);			//o͊҂

	return 0;
}
	
BYTE I2C_NIXIE_read(BYTE p_unit_no, BYTE p_read_address, BYTE *p_read_data, BYTE p_data_len)
{
	BYTE chip_address;
	BYTE fi;

	// p[^`FbN
	if(p_unit_no <= 0 || NIXIE_UNIT_MAX_NUM < p_unit_no)
	{	// ERROR
		return 1;
	}

	StartI2C();						//X^[go
	while(SSPCON2bits.SEN);			//o͊҂
	chip_address = Nixie_Unit_Address[p_unit_no-1];
	I2C_NIXIE_DataTrans(chip_address);		//`bvAhXƐf[^o
	I2C_NIXIE_DataTrans(p_read_address);	// ǂݍ݃AhX
	RestartI2C();
	while(SSPCON2bits.SEN);			//o͊҂
	chip_address = Nixie_Unit_Address[p_unit_no-1] | 0x01;
	I2C_NIXIE_DataTrans(chip_address);		//`bvAhXƐf[^o

	for(fi = 0; fi < p_data_len; fi++)
	{
		*p_read_data = ReadI2C();
		p_read_data++;

		if(fi == (sizeof(UN_NIXIE_UNIT)-1))
		{
			NotAckI2C();
		}
		else
		{
			AckI2C();
		}
	}

	StopI2C();						//Xgbvo
	while(SSPCON2bits.SEN);			//o͊҂

	return 0;
}


