#include <i2c.h>
#include "i2c_rtc.h"

unsigned char RTC_sec;
unsigned char RTC_min;
unsigned char RTC_hour;
unsigned char RTC_day;
unsigned char RTC_DotW;		//Day of the week@j
unsigned char RTC_month;
unsigned char RTC_year;


unsigned char RTC_set_sec;
unsigned char RTC_set_min;
unsigned char RTC_set_hour;
unsigned char RTC_set_day;
unsigned char RTC_set_DotW;
unsigned char RTC_set_month;
unsigned char RTC_set_year;


void I2C_RTC_init(void);
void I2C_RTC_read(void);
void I2C_RTC_write(void);
void DataTrans( char data);


void I2C_RTC_init(void)
{
	BYTE b_temp;
#if 1
	// VL@bit̓ǂݏo
	StartI2C();						//X^[go
	while(SSPCON2bits.SEN);			//o͊҂
	DataTrans(0xa2);				//`bvAhXƐf[^o
	DataTrans(0x02);
	StartI2C();						//X^[go
	while(SSPCON2bits.SEN);			//o͊҂
	DataTrans(0xa3);				//`bvAhXƐf[^o
	b_temp = ReadI2C(); 			// 02 b
	NotAckI2C();
	StopI2C();						//Xgbvo
	while(SSPCON2bits.SEN);			//o͊҂
	
	if( (b_temp & 0x80) != 0 )
	{	// VL bit ON {
		StartI2C();
		while(SSPCON2bits.SEN);
		DataTrans(0xa2);				//`bvAhXƐf[^o
		DataTrans(0x00);				// address
		DataTrans(0x20);				// 00 control1 STOP bit=1
		DataTrans(0x00);				// 01 control2
		DataTrans(0x56);				// 02 second
		DataTrans(0x34);				// 03 minute
		DataTrans(0x12);				// 04 hour
		DataTrans(RTC_DAY_DEFAULT);		// 05 day
		DataTrans(RTC_DOW_DEFAULT);		// 06 day of week
		DataTrans(RTC_MONTH_DEFAULT);	// 07 month
		DataTrans(RTC_YEAR_DEFAULT);	// 08 year
		DataTrans(0x80);				// 09 Minute Alarm
		DataTrans(0x80);				// 0A Hour Alarm
		DataTrans(0x80);				// 0B Day Alarm
		DataTrans(0x80);				// 0C Weekday Alarm
		DataTrans(0x80);				// 0D CLKOUT frequency
		DataTrans(0x00);				// 0E Timer control
		DataTrans(0x00);				// 0F Timer
		StopI2C();						//Xgbvo
		while(SSPCON2bits.SEN);			//o͊҂
		
		// STOP bit
		StartI2C();
		while(SSPCON2bits.SEN);
		DataTrans(0xa2);				//`bvAhXƐf[^o
		DataTrans(0x00);				// address
		DataTrans(0x00);				// 00 control1 STOP bit=0
		StopI2C();						//Xgbvo
		while(SSPCON2bits.SEN);			//o͊҂
	}
#endif	
}
	
void DataTrans( char data)
{
	WriteI2C(data);						//f[^o͎s
	IdleI2C();							//oXACh҂
}


void I2C_RTC_read(void)
{
	StartI2C();							//X^[go
	while(SSPCON2bits.SEN);			//o͊҂
	DataTrans(0xa2);		//`bvAhXƐf[^o
	DataTrans(0x02);
	StartI2C();							//X^[go
	while(SSPCON2bits.SEN);			//o͊҂
	DataTrans(0xa3);				//`bvAhXƐf[^o
	RTC_sec = ReadI2C() & 0x7f; 		// 02 b
	AckI2C();
	RTC_min = ReadI2C() & 0x7f;		// 03 
	AckI2C();
	RTC_hour = ReadI2C() & 0x3f; 		// 04 
	AckI2C();
	RTC_day = ReadI2C() & 0x3f; 		// 05 
	AckI2C();
	RTC_DotW = ReadI2C() & 0x07; 		// 06 j
	AckI2C();
	RTC_month = ReadI2C() & 0x1f; 		// 07 
	AckI2C();
	RTC_year = ReadI2C();        		// 08 N
	NotAckI2C();
	StopI2C();							//Xgbvo
	while(SSPCON2bits.SEN);			//o͊҂
}

void I2C_RTC_write(void)
{
	StartI2C();
	while(SSPCON2bits.SEN);
	DataTrans(0xa2);		//`bvAhXƐf[^o
	DataTrans(0x02);
	DataTrans(RTC_set_sec);
	DataTrans(RTC_set_min);
	DataTrans(RTC_set_hour);
	DataTrans(RTC_set_day);
	DataTrans(RTC_set_DotW);
	DataTrans(RTC_set_month);
	DataTrans(RTC_set_year);
	StopI2C();							//Xgbvo
	while(SSPCON2bits.SEN);			//o͊҂
}

